/* @(#)pattern.c 1.14 Software Membership 2/17/96 */
/*
	SM/Editor - Version 2

    ---------
    Copyright (C) Si-Won Cho
            Dept. of Electrical Engineering
            Dongguk University
            Seoul, KOREA
            chosw@dgu4680.dongguk.ac.kr

            SAMSUNG Electronics
            Software Membership

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    ---------
*/

#include <stdio.h>
#include <string.h>
#ifdef hpux
#include <strings.h>
#endif
#include <Xm/Text.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/LabelG.h>
#include <Xm/ToggleBG.h>
#include <Xm/Frame.h>
#include <Xm/RowColumn.h>
#include <Xm/MessageB.h>
#include "strctrl.h"

struct _ReplaceRec {
	Widget	form;
	Widget	frame_input;
	Widget	form_input;
	Widget	find_w, label_f;
	Widget	replace_w, label_r;
	Widget	set_origin;
	Widget	label_1, frame_opt, rowcol_toggle, toggle_1, toggle_2;
	Widget	label_2, frame_dir, radio_box, toggle_3, toggle_4;
	Widget	Find, Replace, ReplaceAll, Close;
	Widget	message_dialog;
} FR_DIALOG;	/* Find & Replace Dialog Struct */

/*      Global Variables        */
Boolean	found = False;

/*      Common Variables in Find & Replace Part  */
static char *search_str;
static char *replace_str;
static XmTextPosition search_len;
static XmTextPosition replace_len;
static char *str;
static XmTextPosition str_len;
XmTextPosition pos = -2L;

Boolean case_sensitive = True;		/* Case sensitive */
Boolean whole_words_only = False;	/* Whole words only */
Boolean forward = True;			/* Forward  or Backward */
int	SearchStart = 0;
Boolean Start_new = False;

#ifdef _NO_PROTO
void toggle_cb();
void setStart_cb();
void replace_cb();
void closedialog_cb();
void ValueChange_cb();
#else /* _NO_PROTO */
void toggle_cb(Widget, XtPointer, XtPointer);
void setStart_cb(Widget, XtPointer, XtPointer);
void replace_cb(Widget, XtPointer, XtPointer);
void closedialog_cb(Widget, XtPointer, XtPointer);
void ValueChange_cb(Widget, XtPointer, XtPointer);
#endif

#ifdef _NO_PROTO
void setDialogMessage(w, str)
Widget w;
char *str;
#else
void setDialogMessage(Widget w, char *str)
#endif
{
	XmString label;

	label = XmStringCreateLtoR(str, XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues(w,
		XmNmessageString,	label,
		XmNnoResize,		False,
		XmNresizePolicy,	XmRESIZE_ANY,
		NULL);
	XmStringFree(label);
	XtVaSetValues(w,
		XmNnoResize,		True,
		XmNresizePolicy,	XmRESIZE_NONE,
		NULL);
}

#ifdef _NO_PROTO
Widget smCreateSearchDialog(parent, name)
Widget parent;
char *name;
#else
Widget smCreateSearchDialog(Widget parent, char *name)
#endif
{
	Arg args[4];
	XmString str;

	XtSetArg(args[0], XmNautoUnmanage,	False);
	XtSetArg(args[1], XmNnoResize,		True);
	XtSetArg(args[2], XmNresizePolicy,	XmRESIZE_NONE);

	FR_DIALOG.form = XmCreateFormDialog(parent, name, args, 3);

        FR_DIALOG.frame_input = XtVaCreateWidget("Frame",
                xmFrameWidgetClass,     FR_DIALOG.form,
		XmNleftAttachment,	XmATTACH_FORM,
		XmNleftOffset,		10,
		XmNtopAttachment,	XmATTACH_FORM,
		XmNtopOffset,		10,
                NULL);

	FR_DIALOG.form_input = XtVaCreateWidget("form_input",
		xmFormWidgetClass,	FR_DIALOG.frame_input,
		NULL);

	FR_DIALOG.find_w = XtVaCreateManagedWidget("FindText",
		xmTextWidgetClass, FR_DIALOG.form_input,
		XmNeditMode,		XmSINGLE_LINE_EDIT,
		XmNcolumns,		25,
		XmNtopAttachment,	XmATTACH_FORM,
/*		XmNtopOffset,		3,*/
		XmNrightAttachment,	XmATTACH_FORM,
		XmNrightOffset,		3,
		NULL);

        FR_DIALOG.label_f = XtVaCreateManagedWidget("FindLabel",
                xmLabelGadgetClass,     FR_DIALOG.form_input,
		XmNtopAttachment,	XmATTACH_OPPOSITE_WIDGET,
		XmNtopWidget,		FR_DIALOG.find_w,
		XmNrightAttachment,	XmATTACH_WIDGET,
		XmNrightWidget,		FR_DIALOG.find_w,
		XmNrightOffset,		3,
		XmNbottomAttachment,	XmATTACH_OPPOSITE_WIDGET,
		XmNbottomWidget,	FR_DIALOG.find_w,
		NULL);

        FR_DIALOG.replace_w = XtVaCreateManagedWidget("ReplaceText",
		xmTextWidgetClass,	FR_DIALOG.form_input,
		XmNeditMode,		XmSINGLE_LINE_EDIT,
		XmNcolumns,		25,
		XmNtopAttachment,	XmATTACH_WIDGET,
		XmNtopWidget,		FR_DIALOG.find_w,
		XmNtopOffset,		3,
		XmNrightAttachment,	XmATTACH_FORM,
		XmNrightOffset,		3,
		XmNbottomAttachment,	XmATTACH_FORM,
/*		XmNbottomOffset,	3,*/
		NULL);

        FR_DIALOG.label_r = XtVaCreateManagedWidget("ReplaceLabel",
                xmLabelGadgetClass,     FR_DIALOG.form_input,
		XmNleftAttachment,	XmATTACH_FORM,
		XmNleftOffset,		3,
		XmNtopAttachment,	XmATTACH_OPPOSITE_WIDGET,
		XmNtopWidget,		FR_DIALOG.replace_w,
		XmNrightAttachment,	XmATTACH_WIDGET,
		XmNrightWidget,		FR_DIALOG.replace_w,
		XmNrightOffset,		3,
		XmNbottomAttachment,	XmATTACH_OPPOSITE_WIDGET,
		XmNbottomWidget,	FR_DIALOG.replace_w,
                NULL);

	XtManageChild(FR_DIALOG.form_input);
	XtManageChild(FR_DIALOG.frame_input);

	FR_DIALOG.set_origin = XmVaCreateSimpleOptionMenu(FR_DIALOG.form,
		"set_origin",
		(XmString)NULL, (KeySym)NULL, 0, setStart_cb,
		XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,
		XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,
		XmNleftAttachment,	XmATTACH_FORM,
		XmNleftOffset,		45,
                XmNtopAttachment,	XmATTACH_WIDGET,
		XmNtopWidget,		FR_DIALOG.frame_input,
		NULL);

	XtManageChild(FR_DIALOG.set_origin);

	FR_DIALOG.label_1 = XtVaCreateManagedWidget("FindOptionsLabel",
		xmLabelGadgetClass,	FR_DIALOG.form,
                XmNleftAttachment,	XmATTACH_FORM,
                XmNleftOffset,		10,
                XmNtopAttachment,	XmATTACH_WIDGET,
                XmNtopWidget,		FR_DIALOG.set_origin,
                XmNtopOffset,		2,
		NULL);

        FR_DIALOG.frame_opt = XtVaCreateWidget("Frame",
                xmFrameWidgetClass,     FR_DIALOG.form,
                XmNtopAttachment,	XmATTACH_WIDGET,
                XmNleftAttachment,	XmATTACH_FORM,
                XmNleftOffset,		10,
                XmNtopWidget,		FR_DIALOG.label_1,
                XmNbottomAttachment,	XmATTACH_FORM,
                XmNbottomOffset,	10,
                NULL);

	FR_DIALOG.rowcol_toggle = XtVaCreateWidget("FindRowCol",
		xmRowColumnWidgetClass,	FR_DIALOG.frame_opt,
		XmNorientation,		XmVERTICAL,
		XmNentryAlignment,	XmALIGNMENT_BEGINNING,
		NULL);

        FR_DIALOG.toggle_1 = XtVaCreateManagedWidget("Toggle1",
                xmToggleButtonGadgetClass, FR_DIALOG.rowcol_toggle,
                XmNset,			case_sensitive,
                NULL);

	XtAddCallback(FR_DIALOG.toggle_1, XmNvalueChangedCallback,
			toggle_cb, (XtPointer)NULL);

        FR_DIALOG.toggle_2 = XtVaCreateManagedWidget("Toggle2",
                xmToggleButtonGadgetClass, FR_DIALOG.rowcol_toggle,
                XmNset,			whole_words_only,
                NULL);

	XtAddCallback(FR_DIALOG.toggle_2, XmNvalueChangedCallback,
			toggle_cb, (XtPointer)NULL);

	XtManageChild(FR_DIALOG.rowcol_toggle);
	XtManageChild(FR_DIALOG.frame_opt);

	FR_DIALOG.label_2 = XtVaCreateManagedWidget("FindDirectionLabel",
		xmLabelGadgetClass,	FR_DIALOG.form,
                XmNleftAttachment,	XmATTACH_WIDGET,
                XmNleftWidget,       	FR_DIALOG.frame_opt,
                XmNleftOffset,		10,
                XmNtopAttachment,	XmATTACH_WIDGET,
                XmNtopWidget,		FR_DIALOG.set_origin,
                XmNtopOffset,		2,
		NULL);

        FR_DIALOG.frame_dir = XtVaCreateWidget("Frame",
                xmFrameWidgetClass,     FR_DIALOG.form,
                XmNleftAttachment,	XmATTACH_WIDGET,
                XmNleftWidget,		FR_DIALOG.frame_opt,
                XmNleftOffset,		10,
                XmNtopAttachment,	XmATTACH_WIDGET,
                XmNtopWidget,		FR_DIALOG.label_2,
                XmNrightAttachment,	XmATTACH_OPPOSITE_WIDGET,
                XmNrightWidget,       	FR_DIALOG.frame_input,
                XmNbottomAttachment,	XmATTACH_FORM,
                XmNbottomOffset,	10,
                NULL);

        FR_DIALOG.radio_box = XmCreateRadioBox(FR_DIALOG.frame_dir, "RadioBox",
                        (ArgList)NULL, 0);

        FR_DIALOG.toggle_3 = XtVaCreateManagedWidget("Toggle3",
                xmToggleButtonGadgetClass, FR_DIALOG.radio_box,
                XmNset,			True,
                NULL);

	XtAddCallback(FR_DIALOG.toggle_3, XmNvalueChangedCallback,
			toggle_cb,	(XtPointer)NULL);

        FR_DIALOG.toggle_4 = XtVaCreateManagedWidget("Toggle4",
                xmToggleButtonGadgetClass, FR_DIALOG.radio_box,
                XmNset,			False,
                NULL);

	XtAddCallback(FR_DIALOG.toggle_4, XmNvalueChangedCallback,
			toggle_cb,	(XtPointer)NULL);

        XtManageChild(FR_DIALOG.radio_box);
        XtManageChild(FR_DIALOG.frame_dir);

	FR_DIALOG.Find = XtVaCreateManagedWidget("FindB",
		xmPushButtonWidgetClass, FR_DIALOG.form,
		XmNmarginWidth,		20,
		XmNsensitive,         	False,
		XmNtopAttachment,	XmATTACH_FORM,
		XmNtopOffset,		10,
		XmNleftAttachment,	XmATTACH_WIDGET,
		XmNleftWidget,		FR_DIALOG.frame_input,
		XmNleftOffset,		10,
		XmNrightAttachment,	XmATTACH_FORM,
		XmNrightOffset,		10,
		NULL);

	XtAddCallback(FR_DIALOG.Find,
	        XmNactivateCallback, replace_cb, (XtPointer)0);

        FR_DIALOG.Replace = XtVaCreateManagedWidget("ReplaceB",
		xmPushButtonWidgetClass, FR_DIALOG.form,
		XmNtopAttachment,	XmATTACH_WIDGET,
		XmNtopWidget,         	FR_DIALOG.Find,
		XmNtopOffset,		0,
		XmNleftAttachment,	XmATTACH_WIDGET,
		XmNleftWidget,		FR_DIALOG.frame_input,
		XmNleftOffset,		10,
		XmNrightAttachment,	XmATTACH_FORM,
		XmNrightOffset,		10,
		NULL);

        XtAddCallback(FR_DIALOG.Replace,
                XmNactivateCallback, replace_cb, (XtPointer)1);

        FR_DIALOG.ReplaceAll = XtVaCreateManagedWidget("ReplaceAllB",
		xmPushButtonWidgetClass, FR_DIALOG.form,
                XmNtopWidget,           FR_DIALOG.Replace,
                XmNleftWidget,          FR_DIALOG.frame_input,
                XmNtopAttachment,	XmATTACH_WIDGET,
                XmNtopWidget,           FR_DIALOG.Replace,
                XmNtopOffset,		0,
                XmNleftAttachment,	XmATTACH_WIDGET,
                XmNleftWidget,          FR_DIALOG.frame_input,
                XmNleftOffset,	        10,
                XmNrightAttachment,	XmATTACH_FORM,
                XmNrightOffset,	        10,
                NULL);

        XtAddCallback(FR_DIALOG.ReplaceAll,
                XmNactivateCallback, replace_cb, (XtPointer)2);

	FR_DIALOG.Close = XtVaCreateManagedWidget("CloseB",
		xmPushButtonWidgetClass, 	FR_DIALOG.form,
		XmNtopAttachment,	XmATTACH_OPPOSITE_WIDGET,
		XmNtopWidget,         	FR_DIALOG.frame_dir,
		XmNtopOffset,		0,
		XmNleftAttachment,	XmATTACH_WIDGET,
		XmNleftWidget,        	FR_DIALOG.frame_input,
		XmNleftOffset,		10,
		XmNrightAttachment,	XmATTACH_FORM,
		XmNrightOffset,		10,
		NULL);

	XtAddCallback(FR_DIALOG.Close,
		XmNactivateCallback, closedialog_cb, (XtPointer)NULL);

        XtAddCallback(FR_DIALOG.find_w, XmNmodifyVerifyCallback,
                ValueChange_cb, (XtPointer)FR_DIALOG.Find);

	XtVaSetValues(FR_DIALOG.form,
		XmNdefaultButton,	FR_DIALOG.Find,
		NULL);

	str = XmStringCreateSimple("Search string not found.");

	XtSetArg(args[0], XmNmessageString,	str);
	XtSetArg(args[1], XmNdialogStyle,	XmDIALOG_FULL_APPLICATION_MODAL);
	XtSetArg(args[2], XmNnoResize,		True);
	XtSetArg(args[3], XmNresizePolicy,	XmRESIZE_NONE);

	FR_DIALOG.message_dialog = XmCreateWarningDialog(parent, "MessageDialog",
		args, 4);

	XtUnmanageChild(XmMessageBoxGetChild(FR_DIALOG.message_dialog,
                        XmDIALOG_CANCEL_BUTTON));
        XtUnmanageChild(XmMessageBoxGetChild(FR_DIALOG.message_dialog,
                        XmDIALOG_HELP_BUTTON));

	XmStringFree(str);

	return (FR_DIALOG.form);
}

#ifdef _NO_PROTO
void smManageReplaceText(is_manage)
Boolean is_manage;
#else /* _NO_PROTO */
void smManageReplaceText(Boolean is_manage)
#endif
{
	XtVaSetValues(FR_DIALOG.form,
		XmNnoResize,		False,
		XmNresizePolicy,	XmRESIZE_ANY,
		NULL);
	if (found == True)
	    found = False;
	if (is_manage == True) {
	    if (!XtIsManaged(FR_DIALOG.replace_w)) {
/*	        XtUnmanageChild(FR_DIALOG.form);*/
		XtManageChild(FR_DIALOG.replace_w);
		XtManageChild(FR_DIALOG.label_r);
		XtManageChild(FR_DIALOG.ReplaceAll);
/*		XtManageChild(FR_DIALOG.form);*/
            }
	}
	else {
	    if (XtIsManaged(FR_DIALOG.replace_w)) {
/*	        XtUnmanageChild(FR_DIALOG.form);*/
		XtUnmanageChild(FR_DIALOG.replace_w);
		XtUnmanageChild(FR_DIALOG.label_r);
		XtUnmanageChild(FR_DIALOG.ReplaceAll);
/*		XtManageChild(FR_DIALOG.form);*/
            }
	}
	XtVaSetValues(FR_DIALOG.form,
		XmNnoResize,		True,
		XmNresizePolicy,	XmRESIZE_NONE,
		NULL);
}

/*
#ifdef _NO_PROTO
void find_cb(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
#else
void find_cb(Widget w, XtPointer client_data, XtPointer call_data)
#endif
{
        XmPushButtonCallbackStruct *cbs =
        		(XmPushButtonCallbackStruct *)call_data;
	Widget tw = XtParent(XtParent(XtParent(w)));
	XmTextPosition endpos;
	XmTextPosition left, right;

	case_sensitive = XmToggleButtonGadgetGetState(F_DIALOG.toggle_1);
	whole_words_only = XmToggleButtonGadgetGetState(F_DIALOG.toggle_2);
	forward = XmToggleButtonGadgetGetState(F_DIALOG.toggle_3);

	if (XmTextGetSelectionPosition(tw, &left, &right) == True)
	    XmTextClearSelection(tw, cbs->event->xbutton.time);

	search_str = XmTextGetString(F_DIALOG.find_w);
	search_len = XmTextGetLastPosition(F_DIALOG.find_w);

	str = XmTextGetString(tw);
	str_len = XmTextGetLastPosition(tw);

	if (Start_new) {
	    switch (SearchStart) {
	        case 0 :
	            pos = XmTextGetInsertionPosition(tw);
                    if (found) {
                        if (!forward) pos -= search_len;
                        found = False;
                    }
	            break;
                case 1 :
                    if (forward) pos = 0;
                    else pos = XmTextGetLastPosition(tw);
 		    break;
	    }
	    Start_new = False;
	}
	else {
            pos = XmTextGetInsertionPosition(tw);
            if (found) {
                if (!forward) pos -= search_len;
                found = False;
            }
            else if (SearchStart == 1) {
                if (forward) pos = 0;
                else pos = XmTextGetLastPosition(tw);
            }
	}
	endpos = (forward) ? str_len : 0L;

	if ((pos = smFindString(search_str, search_len, str, str_len, pos,
		endpos, forward, case_sensitive, whole_words_only)) >= 0) {
	    found = True;

            smTextSetInsertionPosition(tw, pos);
	    XmTextSetSelection(tw, pos, pos + search_len,
		cbs->event->xbutton.time);
	}
	else XtManageChild(FR_DIALOG.message_dialog);

	XtFree(search_str);
	XtFree(str);
}
*/

#ifdef _NO_PROTO
void replace_cb(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
#else
void replace_cb(Widget w, XtPointer client_data, XtPointer call_data)
#endif
{
        XmPushButtonCallbackStruct *cbs =
        		(XmPushButtonCallbackStruct *)call_data;
        int item_no = (int)client_data;
	Widget tw = XtParent(XtParent(XtParent(w)));
	static XmTextPosition old_pos = -1L;
	XmTextPosition endpos;
	XmTextPosition left, right;

	case_sensitive = XmToggleButtonGadgetGetState(FR_DIALOG.toggle_1);
	whole_words_only = XmToggleButtonGadgetGetState(FR_DIALOG.toggle_2);
	forward = XmToggleButtonGadgetGetState(FR_DIALOG.toggle_3);

	if (XmTextGetSelectionPosition(tw, &left, &right) == True)
	    XmTextClearSelection(tw, cbs->event->xbutton.time);

	switch (item_no) {
	    case 0 :	/* Find */
  		search_str = XmTextGetString(FR_DIALOG.find_w);
		search_len = XmTextGetLastPosition(FR_DIALOG.find_w);

		str = XmTextGetString(tw);
		str_len = XmTextGetLastPosition(tw);

		pos = XmTextGetInsertionPosition(tw);
		if (old_pos == pos && found == False) {
		    replace_str = XmTextGetString(FR_DIALOG.replace_w);
		    replace_len = XmTextGetLastPosition(FR_DIALOG.replace_w);
		    if (forward)
		        pos += replace_len;
		    XtFree(replace_str);
		}
	        if (Start_new) {
	            switch (SearchStart) {
	                case 0 :
	                    pos = XmTextGetInsertionPosition(tw);
                            if (found) {
                                if (!forward) pos -= search_len;
                                found = False;
                            }
	                    break;
                        case 1 :
                            if (forward) pos = 0;
                            else pos = XmTextGetLastPosition(tw);
 		            break;
	            }
	            Start_new = False;
	        }
	        else {
                    pos = XmTextGetInsertionPosition(tw);
                    if (found) {
                        if (!forward) pos -= search_len;
                        found = False;
                    }
	        }
		endpos = (forward) ? str_len : 0L;

		if ((pos = smFindString(search_str, search_len, str, str_len, pos,
			endpos, forward, case_sensitive, whole_words_only)) >= 0) {
	  	    found = True;
          	    smTextSetInsertionPosition(tw, pos);
	  	    XmTextSetSelection(tw, pos, pos + search_len,
			cbs->event->xbutton.time);
		}
		else XtManageChild(FR_DIALOG.message_dialog);

		XtFree(search_str);
		XtFree(str);
		break;
	    case 1 :	/* Replace */
	        if (!XtIsManaged(FR_DIALOG.replace_w))
	            smManageReplaceText(True);
	        else {
		    if (found) {
		        replace_str = XmTextGetString(FR_DIALOG.replace_w);
		        smTextReplace(tw, pos, pos + search_len, replace_str);
		        old_pos = XmTextGetInsertionPosition(tw);
		        XtFree(replace_str);
		        found = False;
		    }
		    else XtManageChild(FR_DIALOG.message_dialog);
		}
		break;
          case 2 :	/* Replace All */
                if (XtIsSensitive(FR_DIALOG.Find)) {
        	    search_str = XmTextGetString(FR_DIALOG.find_w);
        	    search_len = XmTextGetLastPosition(FR_DIALOG.find_w);
        	    replace_str = XmTextGetString(FR_DIALOG.replace_w);
        	    replace_len = XmTextGetLastPosition(FR_DIALOG.replace_w);
		    if (found) {
		        smTextReplace(tw, pos, pos + search_len, replace_str);
		        found = False;
		    }
		    if (Start_new)
		        Start_new = False;
                    if (SearchStart == 0)
                        pos = XmTextGetInsertionPosition(tw);
                    else {
                        if (forward) pos = 0;
                        else pos = XmTextGetLastPosition(tw);
                    }
                    while (pos >= 0) {
		        str = XmTextGetString(tw);
		        str_len = XmTextGetLastPosition(tw);
		        endpos = (forward) ? str_len : 0L;
                        pos = smFindString(search_str, search_len, str, str_len,
                    	    pos, endpos, forward, case_sensitive, whole_words_only);
		        if (pos >= 0) {
		            smTextSetInsertionPosition(tw, pos);
		            smTextReplace(tw, pos, pos + search_len, replace_str);
		            if (forward)
			        pos += replace_len;
		        }
                        XtFree(str);
		    }
                    XtFree(replace_str);
                    XtFree(search_str);
                }
                else XtManageChild(FR_DIALOG.message_dialog);
		break;
	}
}

#ifdef _NO_PROTO
void findAgain(w)
Widget w;
#else
void findAgain(Widget w)
#endif
{
	XmTextPosition endpos;
	XmTextPosition left, right;
	static XmTextPosition old_pos = -1L;

	if (XmTextGetSelectionPosition(w, &left, &right) == True)
	    XmTextClearSelection(w, CurrentTime);

	case_sensitive = XmToggleButtonGadgetGetState(FR_DIALOG.toggle_1);
	whole_words_only = XmToggleButtonGadgetGetState(FR_DIALOG.toggle_2);
	forward = XmToggleButtonGadgetGetState(FR_DIALOG.toggle_3);

	search_str = XmTextGetString(FR_DIALOG.find_w);
	search_len = XmTextGetLastPosition(FR_DIALOG.find_w);

	str = XmTextGetString(w);
	str_len = XmTextGetLastPosition(w);
	if (Start_new) {
	    switch (SearchStart) {
	        case 0 :
	            pos = XmTextGetInsertionPosition(w);
                    if (found) {
                        if (!forward) pos -= search_len;
                        found = False;
                    }
	            break;
                case 1 :
                    if (forward) pos = 0;
                    else pos = XmTextGetLastPosition(w);
 		    break;
	    }
	    Start_new = False;
	}
	else {
	    pos = XmTextGetInsertionPosition(w);
	    if (found) {
	        if (!forward) pos -= search_len;
	        found = False;
            }
            else {
                if (old_pos == pos && forward)
                    pos += search_len;
            }
	}

	endpos = (forward) ? str_len : 0;

	if ((pos = smFindString(search_str, search_len, str, str_len, pos,
		endpos, forward, case_sensitive, whole_words_only)) >= 0) {
	    found = True;
            smTextSetInsertionPosition(w, pos);
	    XmTextSetSelection(w, pos, pos + search_len, CurrentTime);
	    old_pos = pos;
	}

	XtFree(search_str);
	XtFree(str);

	if (found == False)
	    XtManageChild(FR_DIALOG.message_dialog);
}

#ifdef _NO_PROTO
void ReplaceFindText(w, event, params, num)
Widget w;
XEvent *event;
String *params;
Cardinal *num;
#else
void ReplaceFindText(Widget w, XEvent *event, String *params, Cardinal *num)
#endif
{
	if (found) {
	    XmTextClearSelection(w, CurrentTime);
  	    search_len = XmTextGetLastPosition(FR_DIALOG.find_w);
	    replace_str = XmTextGetString(FR_DIALOG.replace_w);
            smTextReplace(w, pos, pos + search_len, replace_str);
	    XtFree(replace_str);
	    found = False;
	}
	else XtManageChild(FR_DIALOG.message_dialog);
}

#ifdef _NO_PROTO
void closedialog_cb(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
#else /* _NO_PROTO */
void closedialog_cb(Widget w, XtPointer client_data, XtPointer call_data)
#endif
{
	XmPushButtonCallbackStruct *cbs =
        		(XmPushButtonCallbackStruct *)call_data;

	if (found) {
	    XmTextClearSelection(XtParent(XtParent(XtParent(w))),
	  	cbs->event->xbutton.time);
	    found = False;
	}
	XtUnmanageChild(XtParent(w));
}

#ifdef _NO_PROTO
void SelectionToFind(w)
Widget w;
#else
void SelectionToFind(Widget w)
#endif
{
	char *string;
	int size;
	Boolean is_selected;
	XmTextPosition start_p, end_p;

	is_selected = XmTextGetSelectionPosition(w, &start_p, &end_p);
	if (is_selected == True && start_p != end_p) {
	    size = (int)(end_p - start_p);
	    string = XtMalloc((Cardinal)size + 1);
	    if (XmTextGetSubstring(w, start_p, size, size + 1, string) == XmCOPY_SUCCEEDED)
                XmTextSetString(FR_DIALOG.find_w, string);
	    XtFree(string);
	}
}

#ifdef _NO_PROTO
void ValueChange_cb(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
#else
void ValueChange_cb(Widget w, XtPointer client_data, XtPointer call_data)
#endif
{
        Boolean In_string = True;
        XmTextVerifyCallbackStruct *cbs =
        	(XmTextVerifyCallbackStruct *)call_data;
	char *str;
	XmTextPosition len;

	str = XmTextGetString(w);
	len = XmTextGetLastPosition(w);
	if (cbs->text->length > 0) In_string = True;
	else if ((cbs->endPos - cbs->startPos) == len || len == 0)
	    In_string = False;
	XtFree(str);
	Start_new = True;

	XtSetSensitive((Widget)client_data, In_string);
}

#ifdef _NO_PROTO
void toggle_cb(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
#else
void toggle_cb(Widget w, XtPointer client_data, XtPointer call_data)
#endif
{
	XmToggleButtonCallbackStruct *cbs =
        		(XmToggleButtonCallbackStruct *)call_data;

	if (cbs->reason == XmCR_VALUE_CHANGED)
	    Start_new = True;
}

#ifdef _NO_PROTO
void setStart_cb(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
#else
void setStart_cb(Widget w, XtPointer client_data, XtPointer call_data)
#endif
{
	SearchStart = (int)client_data;
	Start_new = True;
}
